using System;
using System.Data;
using bizFacade;
using MesServerWork;
using MesWebFun_base;

namespace MesServerFunctions
{
    partial class FunctionMES
    {
        /// <summary>
        /// 正常逻辑工作(传递机型)
        /// </summary>
        /// <param name="OpName"></param>
        /// <param name="EngineTypeID"></param>
        /// <param name="EngineType"></param>
        /// <param name="EngineID"></param>
        /// <param name="PartPallet_Code"></param>
        private void EngineTypeGetOver_PLC_Work(string OpName, int EngineTypeID, string EngineType, string EngineID, int PartPallet_Code,string OrderForm)
        {
            int IsAllowWork;
            int RepairPartStatusPLC = 0;
            int MES_QualityMask = 1;
            //string OrderForm = "";//订单号
            //DataTable dt;

            if (EngineTypeID <= 0 || EngineID.Length == 0 || EngineType.Length == 0 || OrderForm.Length == 0)
            {
                SendMessageFun.AsyncSendMessage_Notice(OpName, "PLC传递机型为空");
                return;
            }

            if(OpName == "J07MA115")
            {
                string message = "MES|ShowTipBox|" + OpName + "|请注意刮胶！";
                SendMessage.AsyncSendMessage(message);
                //SendMessageFun.AsyncSendMessage_Notice(OpName, "请注意刮胶");
            }

            //获取返工订单数据
            DataTable dt = new DataTable();
            dt = BaseDataSystemMES.Get_BackWorkData(EngineID);
            if(dt.Rows.Count > 0)
            {
                string Back_OpName = dt.Rows[0]["工位号"].ToString();

                //通知web显示  在返修工位显示故障来源工位的物料数据与工艺图片
                //物料数据
                MesWebFun_base.MesWebFun_base mb = new MesWebFun_base.MesWebFun_base();
                string MaterialListStr = mb.ProcessRequest("MaterialList", Back_OpName);
                string message = "MES|MaterialList_Resources|" + OpName + "|" + MaterialListStr;
                SendMessage.AsyncSendMessage(message);
                //工艺图片
                string PictureShowStr = mb.ProcessRequest("PictureShow", Back_OpName);
                message = "MES|PicShow_Resources|" + OpName + "|" + PictureShowStr;
                SendMessage.AsyncSendMessage(message);
            }
            else
            {
                SendMessageFun.AsyncSendMessage_Notice(OpName, "该返修件故障工位未记录！请注意！");
            }

            SendMessageFun.SendMessage("1235", "1111", OpName);
            MIS_BASE.Read_PalletInfo(OpName, out MES_QualityMask);//合格标志
            MIS_BASE.Read_RepairStatus_PLC(OpName, out RepairPartStatusPLC);//返修标志
            SendMessageFun.SendInfomation("QualityMask", Convert.ToString(MES_QualityMask), OpName);//显示合格标志
            SendMessageFun.SendInfomation("RepairPartStatusPLC", Convert.ToString(RepairPartStatusPLC), OpName);//显示返修标志

            if (MES_QualityMask == 2)
            {
                //// 工作完成
                //MIS_BASE.Write_MaterialVerifyOver(OpName, true);
                //SendMessageFun.SendInfomation("NgGO", "1", OpName);//显示不合格标志
                //return;
            }


            //第三步，用于工件离开后完工数量统计及工件编号追溯
            //BaseDataSystemMES.MaterialPush_EngineIDStatus_Insert(OpName);//更新订单产量

            //第四步，获取是否允许工作
            BaseDataSystemMES.MesServer_Judge_IsCanWork(OpName, out IsAllowWork);

            //暂时先定义为扫描完成才能进行压装工作，因为考虑到工作完成后，操作工未必会去扫描物料的情况
            if (IsAllowWork == 1)
            {
                //通知PLC允许工作,允许工作在保存完成时清空
                MIS_BASE.Write_FixAllow(OpName, true);
            }
            else
            {
                SendMessageFun.AsyncSendMessage_Notice(OpName, "请扫描物料！");
            }

        }

  
        /// <summary>
        /// 返修件需要工作
        /// </summary>
        /// <param name="OpName">工位号</param>
        private void IsNeedRepaire_OK(string OpName)
        {
            string orderForm = "";
            int engineTypeID;
            string engineType = "";
            string engineID = "";
            string palletCode = "";
            int isRepair;
            string repairCode = "";
            //从监控系统中查询出本工位信息
            BaseDataSystemMES.OpName_MIS_Moby_Select(OpName,
            out  orderForm, out  engineTypeID, out  engineType,
            out  engineID, out palletCode, out isRepair, out repairCode);

            EngineTypeGetOver_PLC_Work(OpName, engineTypeID, engineType, engineID, Convert.ToInt32(palletCode),orderForm);
        }




    }
}
